class TextView {

  int _width, _height;
  int _title_author_y, _poem_y;
  int _phoneme_offset, _histogram_offset, _poem_width;
  int _view_offset;
  float longest_line;
  //int[] exp = new int[Experiments.length];
  int graphx = 800;
  int graphy = 20;
  int numNodes = 0;

  //lev distance
  //DamerauLevenshteinAlgorithm DLs;

  PFont _line_font, _line_fontb, _phoneme_line_font;

  //ArrayList< ArrayList<Set> > RhymeSets = new ArrayList< ArrayList<Set> >();  

  TextView() { 
    _line_font = _georgia_14;
    _line_fontb = _georgia_14b;
    _phoneme_line_font = _clairhand_14;

    _title_author_y = 0;
    _poem_y = 24 + 16 + 30;

    _view_offset = 40;

    /*Word test = new Word("end",1);
     Word test2 = new Word("bend",1);
     
     println(rhymePairStr(test2, test, 1));*/
    //println(charCluster(test2, test, 3));

    //compute title length
    textFont( _georgia_24b );
    int title_l = (int)textWidth(_poem.getTitle());

    // compute the length of the longest line (bad approximation!)
    textFont( _line_font );
    int c_l = (int)textWidth( "s" );

    //_phoneme_offset = c_l*_longest_line_length + _view_offset;
    _phoneme_offset = (c_l*_longest_line_length > title_l) ? c_l*_longest_line_length + _view_offset : title_l + _view_offset; 
    _poem_width = c_l*_longest_line_length + _view_offset;
    _histogram_offset = _phoneme_offset*2;
  }

  // this is called when the window size changes
  void setDimensions( int w, int h ) {
    _width = w;
    _height = h;
  }


  void findRhymes() {
    ArrayList<Set> combined = new ArrayList<Set>();
    RhymeSets.clear();
    if (combineRules) {
      RhymeSets.add(new ArrayList<Set>()); //add new array of rhyme sets
      //println("Ok...");
      renderCombinedRhymes();
    } else {
      for (int i = 0; i < rules.size (); i++) {
        RhymeSets.add(new ArrayList<Set>()); //add new array of rhyme sets
        renderRhymes(rules.get(i), i);
      }
    }
  }

  ////////////////////find rhymesets////////////////
  void renderRhymes(rhymerule _rule, int ruleNum) {
    int start;
    boolean first;
    ArrayList<Integer> sets = new ArrayList<Integer>();
    ArrayList<String> res1;

    Line l, m;
    Word[] words, words2;

    for ( int k = 0; k < _poem.getNumLines (); k++ ) {  //looping through lines. 

      l = _poem.getLine(k);
      words = l.getWords();

      currWords1 = words; //for cross words

        for (int i = 0; i < words.length; i++) {
        if (words[i]._exists == false || words[i].isWord == false) {
          continue;
        }

        first = true;
        boolean duplicate = false;
        

        for ( int h = k; h < _poem.getNumLines (); h++ ) {      //looping through all other words after word[i]
          m = _poem.getLine(h);

          words2 = m.getWords();

          currWords2 = words2; //for crossWords

          if (h==k) {
            start = i+1;
          } else {
            start = 0;
          } 
          for (int j = start; j < words2.length; j++) { 
            if (words2[j]._exists == false || words2[j].isWord == false) {
              continue;
            }
            //detect rhyme
            /*if(combineRules){ //make more efficient
             int cont = 0;
             String seg = "";
             for (int ru = 0; ru < rules.size (); ru++) { //if any don't have matches, move to next...
             ArrayList<String> result2 = rhymePairRule(words[i], words2[j], rules.get(ru));
             if(result2.size() == 0){
             cont = 1; 
             } //fix this! make combined sets...
             }
             if(cont == 1){
             continue;
             } 
             }*/

            ArrayList<String> result = rhymePairRule2(words[i], words2[j], _rule, i, j, false);
            //println("res: "+result);
            if (_rule.bimatch) {
              result.addAll(rhymePairRule2(words2[j],words[i], _rule, i, j, true));
              //result.addAll(rhymePairRule2(words2[j], words[i], _rule, j, i, true)); //if bimatch - try other direction - may need to do this regardless
            }
            if (result.size() == 0) { //no match - move to next word
              continue;
            }
            //println("what we're working with... "+result);
            //println(result);
            for (int ii = 0; ii < result.size (); ii++) { //loop through all poss matches
              duplicate = false;
              int set = 100000;
              //check to see if rhyme alread exists, in which case, add to existing. Otherwise...
              for (int n = 0; n < RhymeSets.get (ruleNum).size(); n++) {
                if (result.get(ii).equals(RhymeSets.get(ruleNum).get(n)._rhymeId)) {
                  //println("yep!");
                  //&& RhymeSets.get(ruleNum).get(n)._wrds.get(0) == words[i]
                  //check each rhyme independently
                  int f = 0;
                  /*ArrayList<String> res4 = new ArrayList<String>();
                  for (int mm = 0; mm < RhymeSets.get (ruleNum).get(n)._wrds.size(); mm++) {
                  res4.clear();
                  res4.addAll(words[i].currRes);
                  res4.retainAll(RhymeSets.get(ruleNum).get(n)._wrds.get(mm).currRes); //this wont quite work
                  if(res4.size() == 0 && _rule.bimatch){
                    res4.clear();
                    res4.addAll(words[i].currRes);
                    res4.retainAll(RhymeSets.get(ruleNum).get(n)._wrds.get(mm).currRes); //this wont quite work
                    }
                    
                    if((res4.size() > 0 && !_rule.noMatch) || (res4.size() == 0 && _rule.noMatch)){
                      
                    }else{
                      f++;
                    }  
                    
                  }*/
                  if(_rule.bimatch || _rule.noMatch){
                  ArrayList<String> result2 = new ArrayList<String>();
                  ArrayList<String> result3 = new ArrayList<String>();
                  for (int mm = 0; mm < RhymeSets.get (ruleNum).get(n)._wrds.size(); mm++) {
                    //println(mm);
                    if(words[i] == RhymeSets.get(ruleNum).get(n)._wrds.get(mm)){
                    result2.add("equals");
                    result3 = rhymePairRule2(words2[j], RhymeSets.get(ruleNum).get(n)._wrds.get(mm), _rule, i, j, false);
                    //println("res3: "+result3);
                    }else if(words2[j] == RhymeSets.get(ruleNum).get(n)._wrds.get(mm)){
                    result3.add("equals");  
                    result2 = rhymePairRule2(words[i], RhymeSets.get(ruleNum).get(n)._wrds.get(mm), _rule, i, j, false);
                    //println("res2: "+result2);
                    }else{
                      result2 = rhymePairRule2(words[i], RhymeSets.get(ruleNum).get(n)._wrds.get(mm), _rule, i, j, false);
                      result3 = rhymePairRule2(words2[j], RhymeSets.get(ruleNum).get(n)._wrds.get(mm), _rule, i, j, false);
                    }
                    if (_rule.bimatch) {
                      if(words[i] != RhymeSets.get(ruleNum).get(n)._wrds.get(mm)){
                      result2.addAll(rhymePairRule2(RhymeSets.get(ruleNum).get(n)._wrds.get(mm), words[i], _rule, j, i, true)); //if bimatch - try other direction - may need to do this regardless
                      }
                      if(words2[j] == RhymeSets.get(ruleNum).get(n)._wrds.get(mm)){
                      result3.addAll(rhymePairRule2(RhymeSets.get(ruleNum).get(n)._wrds.get(mm), words2[j], _rule, j, i, true));  
                      }
                    }
                    if (result2.size() == 0 || result3.size() == 0) {
                      //println("rs: "+result2.size()+" r3: "+result3.size());
                      f++;
                    }
                    result2.clear();
                    result3.clear();
                    //println("f: "+f);
                  }
                  }
                  if(f > 0){
                    duplicate = false; 
                  }else{
                    duplicate = true;
                    set = n; 
                  }
                }
              }
              //duplicate = false;
              if (duplicate == false) {  //create new rhyme set
                //println("new set!");
                Set _set = new Set(ruleNum);
                _set._setIds.add(words[i].wrdcount);
                _set._setIds.add(words2[j].wrdcount);
                _set._wrds.add(words[i]);
                _set._wrds.add(words2[j]);
                ///*":"+words[i].pronNum+*//*":"+words2[j].pronNum+*/
                _set._words.add(words[i].getDisplayWord()+"("+words[i].wrdcount+")");
                _set._words.add(words2[j].getDisplayWord()+"("+words2[j].wrdcount+")");
                _set._rhymeId = result.get(ii);
                _set._crossWrd = _rule.crossWrd;
                RhymeSets.get(ruleNum).add(_set);
              } else if (duplicate == true && set != 100000) {
                boolean dup1 = false;
                boolean dup2 = false;
                int num = 10000;
                for (int it = 0; it < RhymeSets.get (ruleNum).get(set)._setIds.size(); it++) {
                  if (words[i].wrdcount == RhymeSets.get(ruleNum).get(set)._setIds.get(it)) {
                    dup1 = true;
                  } else if (words2[j].wrdcount == RhymeSets.get(ruleNum).get(set)._setIds.get(it)) {
                    dup2 = true; 
                    num = it;
                  }
                  //num = it;
                  //println("duplicate!");
                }
                if (dup1 == false && num != 10000) {
                  RhymeSets.get(ruleNum).get(set)._setIds.add(num, words[i].wrdcount); 
                  RhymeSets.get(ruleNum).get(set)._words.add(num, words[i].getDisplayWord()+"("+words[i].wrdcount+")"); 
                  RhymeSets.get(ruleNum).get(set)._wrds.add(num, words[i]);
                }
                if (dup2 ==  false) {
                  RhymeSets.get(ruleNum).get(set)._setIds.add(words2[j].wrdcount); 
                  RhymeSets.get(ruleNum).get(set)._words.add(words2[j].getDisplayWord()+"("+words2[j].wrdcount+")");
                  RhymeSets.get(ruleNum).get(set)._wrds.add(words2[j]);
                }
              }
            }//for (ii)
          }
        }
      }
    }
   // combineSets(ruleNum);
  }
  
  void renderRhymesB(rhymerule _rule, int ruleNum) {
    int start;
    boolean first;
    ArrayList<Integer> sets = new ArrayList<Integer>();
    ArrayList<String> res1 = new ArrayList<String>();
    ArrayList<String> resB = new ArrayList<String>();

    Line l, m;
    Word[] words, words2;

    for ( int k = 0; k < _poem.getNumLines (); k++ ) {  //looping through lines. 

      l = _poem.getLine(k);
      words = l.getWords();

      currWords1 = words; //for cross words

        for (int i = 0; i < words.length; i++) {
        if (words[i]._exists == false || words[i].isWord == false) {
          continue;
        }

        first = true;
        boolean duplicate = false;
        res1 = rhymePairRuleSingle(words[i], _rule, i, false);
        if(_rule.bimatch){
        resB = rhymePairRuleSingle(words[i], _rule, i, true);
        }

        for ( int h = k; h < _poem.getNumLines (); h++ ) {      //looping through all other words after word[i]
          m = _poem.getLine(h);

          words2 = m.getWords();

          currWords2 = words2; //for crossWords

          if (h==k) {
            start = i+1;
          } else {
            start = 0;
          } 
          
          for (int j = start; j < words2.length; j++) { 
            if (words2[j]._exists == false || words2[j].isWord == false) {
              continue;
            }
            
            
            res1 = rhymePairRuleSingle(words[i], _rule, i, false);
            //ArrayList<String> result = rhymePairRuleC(res1, words[i], words2[j], _rule, i, j, false);
            //res1 = rhymePairRuleSingle(words[i], _rule, i, false);  
            ArrayList<String> result = rhymePairRuleB(res1, words[i], words2[j], _rule, j, false);
            if (_rule.bimatch) {
              result.addAll(rhymePairRule2(words2[j], words[i], _rule, j, i, true));
             // result.addAll(rhymePairRuleB(resB, words[i], words2[j], _rule, j, true)); //if bimatch - try other direction - may need to do this regardless
            }
            if (result.size() == 0) { //no match - move to next word
              continue;
            }
            //println("what we're working with... "+result);
            //println(result);
            for (int ii = 0; ii < result.size (); ii++) { //loop through all poss matches
              duplicate = false;
              int set = 100000;
              //check to see if rhyme alread exists, in which case, add to existing. Otherwise...
              for (int n = 0; n < RhymeSets.get (ruleNum).size(); n++) {
                if (result.get(ii).equals(RhymeSets.get(ruleNum).get(n)._rhymeId)) {
                  //println("yep!");
                  //&& RhymeSets.get(ruleNum).get(n)._wrds.get(0) == words[i]
                  //check each rhyme independently
                  int f = 0;
                  /*ArrayList<String> res4 = new ArrayList<String>();
                  for (int mm = 0; mm < RhymeSets.get (ruleNum).get(n)._wrds.size(); mm++) {
                  res4.clear();
                  res4.addAll(words[i].currRes);
                  res4.retainAll(RhymeSets.get(ruleNum).get(n)._wrds.get(mm).currRes); //this wont quite work
                  if(res4.size() == 0 && _rule.bimatch){
                    res4.clear();
                    res4.addAll(words[i].currRes);
                    res4.retainAll(RhymeSets.get(ruleNum).get(n)._wrds.get(mm).currRes); //this wont quite work
                    }
                    
                    if((res4.size() > 0 && !_rule.noMatch) || (res4.size() == 0 && _rule.noMatch)){
                      
                    }else{
                      f++;
                    }  
                    
                  }*/
                  if(_rule.bimatch || _rule.noMatch){
                  ArrayList<String> result2 = new ArrayList<String>();
                  ArrayList<String> result3 = new ArrayList<String>();
                  for (int mm = 0; mm < RhymeSets.get (ruleNum).get(n)._wrds.size(); mm++) {
                    //println(mm);
                    if(words[i] == RhymeSets.get(ruleNum).get(n)._wrds.get(mm)){
                    result2.add("equals");
                    result3 = rhymePairRule2(words2[j], RhymeSets.get(ruleNum).get(n)._wrds.get(mm), _rule, i, j, false);
                    //println("res3: "+result3);
                    }else if(words2[j] == RhymeSets.get(ruleNum).get(n)._wrds.get(mm)){
                    result3.add("equals");  
                    result2 = rhymePairRule2(words[i], RhymeSets.get(ruleNum).get(n)._wrds.get(mm), _rule, i, j, false);
                    //println("res2: "+result2);
                    }else{
                      result2 = rhymePairRule2(words[i], RhymeSets.get(ruleNum).get(n)._wrds.get(mm), _rule, i, j, false);
                      result3 = rhymePairRule2(words2[j], RhymeSets.get(ruleNum).get(n)._wrds.get(mm), _rule, i, j, false);
                    }
                    if (_rule.bimatch) {
                      if(words[i] != RhymeSets.get(ruleNum).get(n)._wrds.get(mm)){
                      result2.addAll(rhymePairRule2(RhymeSets.get(ruleNum).get(n)._wrds.get(mm), words[i], _rule, j, i, true)); //if bimatch - try other direction - may need to do this regardless
                      }
                      if(words2[j] == RhymeSets.get(ruleNum).get(n)._wrds.get(mm)){
                      result3.addAll(rhymePairRule2(RhymeSets.get(ruleNum).get(n)._wrds.get(mm), words2[j], _rule, j, i, true));  
                      }
                    }
                    if (result2.size() == 0 || result3.size() == 0) {
                      //println("rs: "+result2.size()+" r3: "+result3.size());
                      f++;
                    }
                    result2.clear();
                    result3.clear();
                    //println("f: "+f);
                  }
                  }
                  if(f > 0){
                    duplicate = false; 
                  }else{
                    duplicate = true;
                    set = n; 
                  }
                }
              }
              //duplicate = false;
              if (duplicate == false) {  //create new rhyme set
                //println("new set!");
                Set _set = new Set(ruleNum);
                _set._setIds.add(words[i].wrdcount);
                _set._setIds.add(words2[j].wrdcount);
                _set._wrds.add(words[i]);
                _set._wrds.add(words2[j]);
                ///*":"+words[i].pronNum+*//*":"+words2[j].pronNum+*/
                _set._words.add(words[i].getDisplayWord()+"("+words[i].wrdcount+")");
                _set._words.add(words2[j].getDisplayWord()+"("+words2[j].wrdcount+")");
                _set._rhymeId = result.get(ii);
                _set._crossWrd = _rule.crossWrd;
                RhymeSets.get(ruleNum).add(_set);
              } else if (duplicate == true && set != 100000) {
                boolean dup1 = false;
                boolean dup2 = false;
                int num = 10000;
                for (int it = 0; it < RhymeSets.get (ruleNum).get(set)._setIds.size(); it++) {
                  if (words[i].wrdcount == RhymeSets.get(ruleNum).get(set)._setIds.get(it)) {
                    dup1 = true;
                  } else if (words2[j].wrdcount == RhymeSets.get(ruleNum).get(set)._setIds.get(it)) {
                    dup2 = true; 
                    num = it;
                  }
                  //num = it;
                  //println("duplicate!");
                }
                if (dup1 == false && num != 10000) {
                  RhymeSets.get(ruleNum).get(set)._setIds.add(num, words[i].wrdcount); 
                  RhymeSets.get(ruleNum).get(set)._words.add(num, words[i].getDisplayWord()+"("+words[i].wrdcount+")"); 
                  RhymeSets.get(ruleNum).get(set)._wrds.add(num, words[i]);
                }
                if (dup2 ==  false) {
                  RhymeSets.get(ruleNum).get(set)._setIds.add(words2[j].wrdcount); 
                  RhymeSets.get(ruleNum).get(set)._words.add(words2[j].getDisplayWord()+"("+words2[j].wrdcount+")");
                  RhymeSets.get(ruleNum).get(set)._wrds.add(words2[j]);
                }
              }
            }//for (ii)
          }
        }
      }
    }
   // combineSets(ruleNum);
  }
  
  void combineSets(int rNum){
   //sort alphabetically
   Collections.sort(RhymeSets.get(rNum), new setComparable2());
   /*for(int i = 0; i < RhymeSets.get(rNum).size(); i++){
    Set tmp = RhymeSets.get(rNum).get(i);
    while(tmp._rhymeId.equals(RhymeSets.get(rNum).get(i)._rhymeId) && i < RhymeSets.get(rNum).size()){
    i++;  
    Set tmp2 = RhymeSets.get(rNum).get(i);
      for(int i = 0; i < RhymeSets.get(rNum).get(i)._words.size()){
         
      }
    }*/
    /*i++;
    while(tmp._rhymeId.equals(RhymeSets.get(rNum).get(i)._rhymeId) && i < RhymeSets.get(rNum).size()){
      i++;
    }
    println(RhymeSets.get(rNum).get(i)._rhymeId+" : "+RhymeSets.get(rNum).get(i)._words);
    //COME BACK TO THIS!!!
    //sort alpabetically
    //combine sets (two at a time) add [night, bogan] to [night, lake] iff [bogan, lake] exists with same rhyme_id.
    
   }*/
  }
  
  void renderCombinedRhymes() {
    int ruleNum = 0;
    int start;
    boolean first;
    ArrayList<Integer> sets = new ArrayList<Integer>();
    ArrayList<String> res1;

    Line l, m;
    Word[] words, words2;

    for ( int k = 0; k < _poem.getNumLines (); k++ ) {  //looping through lines. 

      l = _poem.getLine(k);
      words = l.getWords();

      currWords1 = words; //for cross words

        for (int i = 0; i < words.length; i++) {
        if (words[i]._exists == false || words[i].isWord == false) {
          continue;
        }

        first = true;
        boolean duplicate = false;
        

        for ( int h = k; h < _poem.getNumLines (); h++ ) {      //looping through all other words after word[i]
          m = _poem.getLine(h);

          words2 = m.getWords();

          currWords2 = words2; //for crossWords

          if (h==k) {
            start = i+1;
          } else {
            start = 0;
          } 
          for (int j = start; j < words2.length; j++) { 
            if (words2[j]._exists == false || words2[j].isWord == false) {
              continue;
            }
            
            ArrayList< ArrayList<String> > resultCombined = new ArrayList< ArrayList<String> >();
            
            if (combineRules) { //make more efficient
              int cont = 0;
              for (int ru = 0; ru < rules.size (); ru++) { //if any don't have matches, move to next...
                ArrayList<String> result2 = rhymePairRule2(words[i], words2[j], rules.get(ru), i, j, false);
                if (rules.get(ru).bimatch) {
                  result2.addAll(rhymePairRule2(words2[j], words[i], rules.get(ru), j, i, true));
                }
                if (result2.size() == 0) {
                  cont = 1;
                } else {
                  resultCombined.add(result2);
                }
              }
              if (cont == 1) {
                continue;
              }
            }
            
            

            /*ArrayList<String> result = rhymePairRule2(words[i], words2[j], _rule, i, j, false);
            if (_rule.bimatch) {
              result.addAll(rhymePairRule2(words2[j],words[i], _rule, i, j, true));
              //result.addAll(rhymePairRule2(words2[j], words[i], _rule, j, i, true)); //if bimatch - try other direction - may need to do this regardless
            }
            if (result.size() == 0) { //no match - move to next word
              continue;
            }*/
            
             ArrayList<String> result = getPermutations(resultCombined);
            
            for (int ii = 0; ii < result.size (); ii++) { //loop through all poss matches
              duplicate = false;
              int set = 100000;
              //check to see if rhyme alread exists, in which case, add to existing. Otherwise...
              for (int n = 0; n < RhymeSets.get (ruleNum).size(); n++) {
                if (result.get(ii).equals(RhymeSets.get(ruleNum).get(n)._rhymeId)) {
                  int f = 0;
                  /*if(_rule.bimatch || _rule.noMatch){
                  ArrayList<String> result2 = new ArrayList<String>();
                  ArrayList<String> result3 = new ArrayList<String>();
                  for (int mm = 0; mm < RhymeSets.get (ruleNum).get(n)._wrds.size(); mm++) {
                    //println(mm);
                    if(words[i] == RhymeSets.get(ruleNum).get(n)._wrds.get(mm)){
                    result2.add("equals");
                    result3 = rhymePairRule2(words2[j], RhymeSets.get(ruleNum).get(n)._wrds.get(mm), _rule, i, j, false);
                    //println("res3: "+result3);
                    }else if(words2[j] == RhymeSets.get(ruleNum).get(n)._wrds.get(mm)){
                    result3.add("equals");  
                    result2 = rhymePairRule2(words[i], RhymeSets.get(ruleNum).get(n)._wrds.get(mm), _rule, i, j, false);
                    //println("res2: "+result2);
                    }else{
                      result2 = rhymePairRule2(words[i], RhymeSets.get(ruleNum).get(n)._wrds.get(mm), _rule, i, j, false);
                      result3 = rhymePairRule2(words2[j], RhymeSets.get(ruleNum).get(n)._wrds.get(mm), _rule, i, j, false);
                    }
                    if (_rule.bimatch) {
                      if(words[i] != RhymeSets.get(ruleNum).get(n)._wrds.get(mm)){
                      result2.addAll(rhymePairRule2(RhymeSets.get(ruleNum).get(n)._wrds.get(mm), words[i], _rule, j, i, true)); //if bimatch - try other direction - may need to do this regardless
                      }
                      if(words2[j] == RhymeSets.get(ruleNum).get(n)._wrds.get(mm)){
                      result3.addAll(rhymePairRule2(RhymeSets.get(ruleNum).get(n)._wrds.get(mm), words2[j], _rule, j, i, true));  
                      }
                    }
                    if (result2.size() == 0 || result3.size() == 0) {
                      //println("rs: "+result2.size()+" r3: "+result3.size());
                      f++;
                    }
                    result2.clear();
                    result3.clear();
                    //println("f: "+f);
                  }
                  }*/
                  if(f > 0){
                    duplicate = false; 
                  }else{
                    duplicate = true;
                    set = n; 
                  }
                }
              }
              //duplicate = false;
              if (duplicate == false) {  //create new rhyme set
                //println("new set!");
                Set _set = new Set(ruleNum);
                _set._setIds.add(words[i].wrdcount);
                _set._setIds.add(words2[j].wrdcount);
                _set._wrds.add(words[i]);
                _set._wrds.add(words2[j]);
                ///*":"+words[i].pronNum+*//*":"+words2[j].pronNum+*/
                _set._words.add(words[i].getDisplayWord()+"("+words[i].wrdcount+")");
                _set._words.add(words2[j].getDisplayWord()+"("+words2[j].wrdcount+")");
                _set._rhymeId = result.get(ii);
                _set._crossWrd = 0;//_rule.crossWrd;
                RhymeSets.get(ruleNum).add(_set);
              } else if (duplicate == true && set != 100000) {
                boolean dup1 = false;
                boolean dup2 = false;
                int num = 10000;
                for (int it = 0; it < RhymeSets.get (ruleNum).get(set)._setIds.size(); it++) {
                  if (words[i].wrdcount == RhymeSets.get(ruleNum).get(set)._setIds.get(it)) {
                    dup1 = true;
                  } else if (words2[j].wrdcount == RhymeSets.get(ruleNum).get(set)._setIds.get(it)) {
                    dup2 = true; 
                    num = it;
                  }
                  //num = it;
                  //println("duplicate!");
                }
                if (dup1 == false && num != 10000) {
                  RhymeSets.get(ruleNum).get(set)._setIds.add(num, words[i].wrdcount); 
                  RhymeSets.get(ruleNum).get(set)._words.add(num, words[i].getDisplayWord()+"("+words[i].wrdcount+")"); 
                  RhymeSets.get(ruleNum).get(set)._wrds.add(num, words[i]);
                }
                if (dup2 ==  false) {
                  RhymeSets.get(ruleNum).get(set)._setIds.add(words2[j].wrdcount); 
                  RhymeSets.get(ruleNum).get(set)._words.add(words2[j].getDisplayWord()+"("+words2[j].wrdcount+")");
                  RhymeSets.get(ruleNum).get(set)._wrds.add(words2[j]);
                }
              }
            }//for (ii)
          }
        }
      }
    }
  }

  void renderCombinedRhymes2() {
    int ruleNum = 0;
    int start;
    boolean first;
    ArrayList<Integer> sets = new ArrayList<Integer>();

    Line l, m;
    Word[] words, words2;

    for ( int k = 0; k < _poem.getNumLines (); k++ ) {  //looping through lines. 

      l = _poem.getLine(k);
      words = l.getWords();

      currWords1 = words;

      for (int i = 0; i < words.length; i++) {
        if (words[i]._exists == false || words[i].isWord == false) {
          continue;
        }

        first = true;
        boolean duplicate = false;

        for ( int h = k; h < _poem.getNumLines (); h++ ) {      //looping through all other words after word[i]
          m = _poem.getLine(h);
          words2 = m.getWords();

          currWords2 = words2;

          if (h==k) {
            start = i+1;
          } else {
            start = 0;
          } 
          for (int j = start; j < words2.length; j++) { 
            if (words2[j]._exists == false || words2[j].isWord == false) {
              continue;
            }
            //detect rhyme
            ArrayList< ArrayList<String> > resultCombined = new ArrayList< ArrayList<String> >();
            if (comment)
              println("Combined: "+resultCombined);
            if (combineRules) { //make more efficient
              int cont = 0;
              for (int ru = 0; ru < rules.size (); ru++) { //if any don't have matches, move to next...
                ArrayList<String> result2 = rhymePairRule2(words[i], words2[j], rules.get(ru), i, j, false);
                if (rules.get(ru).bimatch) {
                  result2.addAll(rhymePairRule2(words2[j], words[i], rules.get(ru), j, i, true));
                }
                if (result2.size() == 0) {
                  cont = 1;
                } else {
                  resultCombined.add(result2);
                }
              }
              if (cont == 1) {
                continue;
              }
            }


            ArrayList<String> result = getPermutations(resultCombined);


            if (result.size() == 0) { //no match - move to next word
              continue;
            }
            if (comment)
              println("Permutations: "+result);


            //println("what we're working with... "+result);
            for (int ii = 0; ii < result.size (); ii++) { //loop through all poss matches
              duplicate = false;
              int set = 100000;
              //check to see if rhyme alread exists, in which case, add to existing. Otherwise...
              for (int n = 0; n < RhymeSets.get (ruleNum).size(); n++) {
                if (result.get(ii).equals(RhymeSets.get(ruleNum).get(n)._rhymeId)) {
                  duplicate = true;
                  set = n;
                }
              }
              if (duplicate == false) {  //create new rhyme set
                if (comment) {
                  println("new set!");
                }
                Set _set = new Set(ruleNum);
                _set._setIds.add(words[i].wrdcount);
                _set._setIds.add(words2[j].wrdcount);
                _set._wrds.add(words[i]);
                _set._wrds.add(words2[j]);

                _set._words.add(words[i].getDisplayWord()+"("+words[i].wrdcount+")");
                _set._words.add(words2[j].getDisplayWord()+"("+words2[j].wrdcount+")");
                _set._rhymeId = result.get(ii);
                RhymeSets.get(ruleNum).add(_set);
              } else if (duplicate == true && set != 100000) {
                boolean dup1 = false;
                boolean dup2 = false;
                int num = 10000;
                for (int it = 0; it < RhymeSets.get (ruleNum).get(set)._setIds.size(); it++) {
                  if (words[i].wrdcount == RhymeSets.get(ruleNum).get(set)._setIds.get(it)) {
                    dup1 = true;
                  } else if (words2[j].wrdcount == RhymeSets.get(ruleNum).get(set)._setIds.get(it)) {
                    dup2 = true; 
                    num = it;
                  }
                  //num = it;
                  //println("duplicate!");
                }
                if (dup1 == false && num != 10000) {
                  RhymeSets.get(ruleNum).get(set)._setIds.add(num, words[i].wrdcount); 
                  RhymeSets.get(ruleNum).get(set)._words.add(num, words[i].getDisplayWord()+"("+words[i].wrdcount+")"); 
                  RhymeSets.get(ruleNum).get(set)._wrds.add(num, words[i]);
                }
                if (dup2 ==  false) {
                  RhymeSets.get(ruleNum).get(set)._setIds.add(words2[j].wrdcount); 
                  RhymeSets.get(ruleNum).get(set)._words.add(words2[j].getDisplayWord()+"("+words2[j].wrdcount+")");
                  RhymeSets.get(ruleNum).get(set)._wrds.add(words2[j]);
                }
              }
            }//for (ii)
          }
        }
      }
    }
  }


  void printRhymeSets(PrintWriter output) {
    output.println("IMPORTANT: please make sure to close file before rerunning program");
    if (combineRules) {
      output.println("\nCombined Rules:");
      for (int i = 0; i < rules.size (); i++) {
        output.println("Rule "+i+": "+rules.get(i).strRule);
      }
      output.println("\nDetected Rhymes:\n");
      for (int j = 0; j < RhymeSets.get (0).size(); j++) {
        output.println(RhymeSets.get(0).get(j)._rhymeId + ": "+RhymeSets.get(0).get(j).printWrds());
        println();
      }
      output.println("\n");
    } else {
      output.println("\nDetected Rhymes\n");
      for (int i = 0; i < rules.size (); i++) {
        output.println("Rule "+i+": "+rules.get(i).strRule);
        for (int j = 0; j < RhymeSets.get (i).size(); j++) {
          output.println(RhymeSets.get(i).get(j)._rhymeId + ": "+RhymeSets.get(i).get(j).printWrds());
        }
        output.println("\n");
      }
    }
  }  

  void printPoemWithIDs(PrintWriter output, PrintWriter uncertainty, String filename) {
    output.println("\n\nPoem with word IDs:\n");
    int count  = 0;
    Line l;
    Word[] words;
    String multis = "";
    String multis2 = "";
    String Lts = "";
    String Lts2 = "";
    for ( int k = 0; k < _poem.getNumLines (); k++ ) {  //looping through lines.
      l = _poem.getLine(k);
      words = l.getWords();
      for (int i = 0; i < words.length; i++) {
        output.print(words[i].getDisplayWord() + "("+words[i].wrdcount+") ");
        if (words[i]._2DSyllables != null && words[i]._2DSyllables.length > 1 && !words[i]._lts) {  //add to list of words with possible modifications
          multis += "\n"+words[i].getDisplayWord();
          multis2 += "\n%"+words[i].getDisplayWord();
          for (int n = 0; n < words[i]._2DSyllables.length; n++) {
            String syll = "";
            for (int m = 0; m < words[i]._2DSyllables[n].length; m++) {
              if (m > 0) {
                syll += " - ";
              }
              syll += words[i]._2DSyllables[n][m].returnStringsp(words[i]._2DSyllables[n][m]._fullSyll);//+words[i]._2DSyllables[n][m]._stress;
            }
            multis += " ("+words[i].wrdcount+":"+n+") "+syll;
            multis2 += " ("+words[i].wrdcount+":"+n+") "+syll;
          }
          multis2 += "\n"+words[i].wrdcount+":"+words[i].pronNum;
          if (customPron[words[i].wrdcount]!= null) {
            multis2 += ":"+customPron[words[i].wrdcount].replaceAll("_", " ").trim();
          }
        }
        if (words[i]._lts) {
          Lts += "\n"+words[i].getDisplayWord();
          Lts2 += "\n%"+words[i].getDisplayWord();
          for (int n = 0; n < words[i]._2DSyllables.length; n++) {
            String syll = "";
            for (int m = 0; m < words[i]._2DSyllables[n].length; m++) {
              if (m > 0) {
                syll += "-";
              }
              syll += " "+words[i]._2DSyllables[n][m].returnStringsp(words[i]._2DSyllables[n][m]._fullSyll);//+words[i]._2DSyllables[n][m]._stress;
            }
            Lts += " ("+words[i].wrdcount+":"+n+") "+syll;
            Lts2 += " ("+words[i].wrdcount+":"+n+") "+syll;
          }
          Lts2 += "\n"+words[i].wrdcount+":"+words[i].pronNum;
          if (customPron[words[i].wrdcount]!= null) {
            Lts2 += ":"+customPron[words[i].wrdcount].replaceAll("_", " ").trim();
          }
        }
      }
      output.println();
      //uncertainty.println();
    }
    output.println("\n\nWords with multiple pronunciations: (word ID: pronunciation number)\nTo change any of the current pronunciations, please see "+filename+"_uncertainty.txt in the Poems directory");
    output.println(multis);
    output.println("\n\nOut-of-dictionary words & pronunciations: (word ID: pronunciation number)\nTo change any of the current pronunciations, please see "+filename+"_uncertainty.txt in the Poems directory");
    output.println(Lts);
    uncertainty.println("IMPORTANT: please make sure to save and close file before rerunning program");
    uncertainty.println("\n\nWords with multiple pronunciations: (word ID: pronunciation number)\nTo change any of the current pronunciations, replace the \"pronunciation number\" (in the uncommented line) the number of your choice");
    uncertainty.println("********Modifications******");
    uncertainty.println(multis2);
    uncertainty.println("********End******");
    uncertainty.println("\n\nOut-of-dictionary words: (word ID: pronunciation number)\nTo change any of the current pronunciations, replace the \"pronunciation number\" (in the uncommented line) the number of your choice");
    uncertainty.println("********Modifications******");
    uncertainty.println(Lts2);
    uncertainty.println("********End******");
  }

  /*void printUncertaintyFile(PrintWriter output) {
   output.println("\n\nPronunciations:\n");
   Line l;
   Word[] words;
   String multis = "";
   for ( int k = 0; k < _poem.getNumLines(); k++ ) {  //looping through lines.
   l = _poem.getLine(k);
   words = l.getWords();
   for (int i = 0; i < words.length; i++) {
   count++;
   if(words[i]._2DSyllables.length > 1){  //add to list of words with possible modifications
   multis += "\n"+words[i].getDisplayWord();
   for (int n = 0; n < words[i]._2DSyllables.length; n++) {
   String syll = "";
   for (int m = 0; m < words[i]._2DSyllables[n].length; m++) {
   if(m > 0){
   syll += "-";
   }
   syll += words[i]._2DSyllables[n][m].returnString(words[i]._2DSyllables[n][m]._fullSyll);
   }
   multis += " ("+words[i].wrdcount+":"+n+") "+syll;
   } 
   }
   }
   output.println();
   }
   output.println("\n\nWords with multiple pronunciations: (word ID: pronunciation number)\nTo change any of the current pronunciations, please see Uncertainty.txt in the Poems directory");
   output.println(multis);
   }*/


  ///////////////////////////detect rhymes//////////////////////////////////



  /////////////////////////// Rhyme Detector //////////////////////////////
  void detectRhyme(String _rhymeRule) {

    //String rule = RhymeRule;  

    rhymerule rule = new rhymerule(_rhymeRule);

    float x = 0;
    float x1 = 0;
    int y = _poem_y;
    int y1 = _poem_y;
    int line_spacing = 5;
    int start;
    boolean first;

    float x1b, y1b, x2b, y2b, x3b, y3b, x4b, y4b;
    x1b = y1b = x2b = y2b = x3b = y3b = x4b = y4b = 0;

    Line l, l2;
    Word[] words, words2;

    //without storing location, etc...
    for ( int k = startRow; k < _poem.getNumLines (); k++ ) {  //looping through lines.
      l = _poem.getLine(k);
      words = l.getWords();   

      for (int i = 0; i < words.length; i++) {

        //skip if not a word
        if (words[i].isWord == false || words[i]._exists == false ) {
          continue;
        }

        first = true;
        boolean duplicate = false;

        for ( int h = k; h < _poem.getNumLines (); h++ ) {
          l2 = _poem.getLine(h);
          words2 = l2.getWords();


          if (h==k) {
            x1 = x+textWidth( words[i].getDisplayWord() + " " );
            start = i+1;
          } else {
            x1 = 0;
            start = 0;
          }

          for (int j = start; j < words2.length; j++) {

            if (words2[j].isWord == false || words2[i]._exists == false) {
              continue;
            }

            //String result = rhymePairRule(words[i], words2[j], rule);
          }//end loop through second words
        } //end second word loop
      }
    }
  } //detect rhyme
}



