//Load existing rules
void addExistingRules() {
  existingRules.add(new rhymerule("Identical Rhyme/Rhyme Riche", "[... - O N C^ - ...]"));
  existingRules.add(new rhymerule("Perfect Masculine", "... - O [N C]'"));
  existingRules.add(new rhymerule("Perfect Feminine", "... - O [N C' - O N C]"));
  existingRules.add(new rhymerule("Perfect Dactylic", "... - O [N C' - O N C - O N C]"));
  existingRules.add(new rhymerule("Semirhyme", "... - O [N C]' & ... - O [N][C]' - [O] N C"));
  existingRules.add(new rhymerule("Syllabic Rhyme", "... - O [N C]' & ... - O [N C]"));
  existingRules.add(new rhymerule("Consonant Slant Rhyme", "... - O N [C`]' - ..."));
  existingRules.add(new rhymerule("Vowel Slant Rhyme", "... - O [N] C' - ..."));
  existingRules.add(new rhymerule("Pararhyme", "... - [O`] N [C`]' - ..."));
  existingRules.add(new rhymerule("Syllabic 2 Rhyme", "O [N C]' - ..."));
  //existingRules.add(new rhymerule("Imperfect consonant slant", "... - O N ~[C]' - ..."));
  existingRules.add(new rhymerule("Alliteration", "...-[O`] N C'-..."));
  existingRules.add(new rhymerule("Assonance", "...-O [N] C^-..."));
  existingRules.add(new rhymerule("Consonance", "...-[O`]|[C`]^-..."));
  existingRules.add(new rhymerule("Forced Rhyme", "...-O [N C_{mv}]'-..."));
  existingRules.add(new rhymerule("Char cluster 2", "...[YY]..."));
  existingRules.add(new rhymerule("Char cluster 2 mixed", "...[YY]*..."));
  existingRules.add(new rhymerule("Anagram", "[...YY...]*"));
  existingRules.add(new rhymerule("Eye rhyme", "!O[NC^-...]"));
}

//class for indivdual rhyme elements

class matchU {
  int type; //0 = syllable; 1 = character; 2 ellipse
  int index_b; //syllable/character index from begining of word
  int bn;
  int en; //0/1 means no/yes preceeding/trailing ellipses;
  int index_e; //syllable/character index from end of word
  int word; //for ':' 0 equals current rules > '0' means proceeding words - not this might run into issues when proceeding word is rhyming word.  
  String subtype; //for syllables O N C; for chars A B or Y
  int stress;  //either 0,1,2 for syllable (2 - either); null for chars
  int mix; //either 0/1 for no/yes for chars; null for sylls. 
  int nellipses;
  boolean struct; //true means phonetic rule for sylls; true means structural (vowel, consonant) for chars
  //ArrayList<String> structStr = new ArrayList<String>(); //to store the struct info
  boolean tilde; //for ~ (both sylls and letters).
  String[] structArray;
  int[] wArray;
  int last;  //distance from last object
  boolean ellipseOn, ellipseOutOn;  //to the right... handle the last after 
  int next;  //distance from last object
  boolean ellipseOnR, ellipseOutOnR;  //to the right... handle the last after 
  boolean rhymeSeg;
  int wrdNum;
  boolean req;
  boolean crossSubt = false;
  
  matchU(matchU m){
    type = m.type; 
    index_b = m.index_b; 
    bn = m.bn;
    index_e = m.index_e; 
    en = m.en;
    nellipses = m.nellipses;
    subtype = m.subtype;
    stress = m.stress;
    mix = m.mix;
    tilde = m.tilde;
    struct = m.struct;
    rhymeSeg = m.rhymeSeg;
    word = m.word;
    //process struct info
    structArray = new String[subtype.length()];
    //hopefully this can transfer too...
    //structArray = new String[subtype.length()]; //this will def be long enough 
    processStruct();
    
  }
  
  //Using this one!
  
  matchU(int t, int ind_b, int ind_e, int _bn, int _en, int numEs, String subt, int _stress, int _mix, boolean _struct, boolean _tilde, boolean _rhymeSeg, int _word, boolean _req) {
    //println("new match "+subt);
    type = t; 
    index_b = ind_b; 
    bn = _bn;
    index_e = ind_e; 
    en = _en;
    nellipses = numEs;
    subtype = subt;
    stress = _stress;
    mix = _mix;
    tilde = _tilde;
    struct = _struct;
    rhymeSeg = _rhymeSeg;
    word = _word;
    req = _req;
    //process struct info
    structArray = new String[subtype.length()]; //this will def be long enough 
    processStruct();
    if(t == 1 && subt.indexOf(":") != -1){
      processWStruct();
    }
  }
  
  
  //Used for "or" functions
  matchU(int t, int ind_b, int ind_e, int _bn, int _en, String subt, int _stress, int _mix, int numEs, boolean struct, boolean _tilde, int _last, boolean _ellipseOn, boolean _ellipseOutOn ) {
    type = t; 
    index_b = ind_b; 
    bn = _bn;
    index_e = ind_e; 
    en = _en;
    subtype = subt;
    stress = _stress;
    mix = _mix;
    nellipses = numEs;
    tilde = _tilde;
    last = _last;
    ellipseOn = _ellipseOn;
    ellipseOutOn = _ellipseOutOn;
    //next = _next;
    //ellipseOnr = _ellipseOnr;
    //ellipseOnOutr = _ellipseOnOutr;
    //process struct info
    structArray = new String[subtype.length()]; //this will def be long enough 
    processStruct();
  }
  
  void processWStruct(){
    wArray = new int[subtype.length()];
    crossSubt = true; 
  }
  
  void processStruct(){
    int ind = 0;
    String tmpStr = "";
    String checkStr = "";
    int ch = 0;
    int ad = 0;
    while(subtype.indexOf("_") != -1){ //struct info
     ad = 0;
     if(type == 1 && ch == 0){ //check if not first
     ch = subtype.indexOf("_")-1;
     }
     if(subtype.indexOf('{') != -1 && subtype.indexOf('}') != -1 && subtype.indexOf('{') < subtype.indexOf('}')){
         tmpStr = subtype.substring(subtype.indexOf('{')+1, subtype.indexOf('}')).toLowerCase();
         //println(tmpStr);
         //check if anything other than mvp - then illegal
         if(type == 0){ //only mvp allowed
         checkStr = tmpStr.replaceAll("[mvp]","");
         }else if(type == 1){ //only s (struct) allow
         checkStr = tmpStr.replaceAll("s","");
         }
         if(checkStr.length() > 0){
          println("Illegal Rule: "+ subtype);
         }else{
         //structStr.add(ch+"_"+tmpStr);
         structArray[ch] = tmpStr;
         }
         int last = subtype.indexOf('}');
         int next = subtype.indexOf('_',last);
         if(next != -1){
           ad = next-last-1;
         }
         subtype = subtype.replaceFirst("_\\{"+tmpStr+"\\}","");
       }else{
        break; 
       }
      ch+=ad;
    }
   if(comment)
   println(structArray);
  }

  ArrayList<String> getMatch(Syllable[] _syll, char[] _wrd) {
    ArrayList<String> res = new ArrayList<String>();
    Syllable tmp;
    String phTmp = "";
    //println("syll length "+_syll.length);
    if (type == 0) { //syllables!
      if ((index_b-nellipses) > _syll.length-1 || (index_e-nellipses) > _syll.length-1) {  //doesn't fit word. This should probably also be checked a step earlier
        println("too short!");
        return res;
      }
      if (en == 0 && bn == 0) {//no ellipses - either side (check that syllable is in correct location
      if(!getONC(_syll[index_b]).equals(getONC(_syll[_syll.length-1-index_e]))){
        println("syll locations do not coincide");
        return res;
      }else{
        phTmp = getONC(_syll[index_b]);
        if (phTmp.length() > 0) {
          res.add(phTmp);
        }
      }
        //}
        return res;
      } else if (bn == 0) { //no ellipses from beg - real val
        //println("from beg");
        //O[NC']-ONC-... -> check that syll is at least one in from the end...
        if(((_syll.length-1)-index_b)< (index_e-en)){
          println("Not far enough from end");
          return res;
        }
        
        phTmp = getONC(_syll[index_b]);
        
        if (phTmp.length() > 0) {
          res.add(phTmp);
        }
        return res;
      } else if (en == 0) { //no ellipse from end
        //println("from end");
        //println(index_e);
        if(((_syll.length-1)-index_e)<(index_b-bn)){
          println("Not far enough from beg");
          return res;
        }
        phTmp = getONC(_syll[_syll.length-1-index_e]);
        if (phTmp.length() > 0) {
          res.add(phTmp);
        }
        return res;
      } else {
        //println("ellipse on either side");
        //ellipse on either side
        if (stress == 1) { //find stressed syllable
          for (int j = 0; j < _syll.length; j++) {
            if (_syll[j]._stress.equals("1"))
              phTmp = getONC(_syll[j]);
          }
          if (phTmp.length() > 0) {
            res.add(phTmp);
          }
          return res;
        } else { //will have many different options - like with consonance/assonance
          for (int j = 0; j < _syll.length; j++) { //check each syllable for possibility
            //println(_syll[j].returnString(_syll[j].getFullSyll()));
            phTmp = getONC(_syll[j]);
            if (phTmp.length() > 0) {
              res.add(phTmp);
            }
          }
          return res;
        }
      }
    } else if (type == 1) { //chars!!!
      if(subtype.length() > _wrd.length){
       //println("word too short");
       return res; 
      }
      if(bn == 0 && en == 0){ //FINISH THIS PART!
        
      }else if(bn == 0){
        
      }else if(en == 0){
        
      }else{
      res = getCluster(_wrd);
      return res;//work on this next
      }
    } 
    return res;
  }
  
  
  //need to take mix into account
  //see if in finite location - if not, then include all possibilities - work location into this...
  ArrayList<String> getCluster(char[] _wrd){
   ArrayList<String> cluster = new ArrayList<String>();
   //ABcAY
   char tmp;
   String tmpMatch;
   
   if(mix == 0){
   for(int i = 0; i <= _wrd.length-subtype.length(); i++){
     //println("length: "+(_wrd.length-subtype.length()));
     tmpMatch = "";
     for(int j = 0; j < subtype.length(); j++){
       tmp = subtype.charAt(j);
       if(Character.isLowerCase(tmp)){ //check if actual character
         if(tmp == _wrd[i+j]){ //char match!
           tmpMatch += "" + _wrd[i+j];
         }else{
          break; //move to next loop 
         }
        } else if(tmp == 'A'){    //check if vowel
           if(isVowel(_wrd[i+j]) || Character.toUpperCase(_wrd[i+j]) == 'Y'){
            if(structArray[j] != null && structArray[j].equals("s")){
              tmpMatch += "V";
            }else{
            tmpMatch += "" + _wrd[i+j];
            }
           }else{
            break; 
           }
         } else if(tmp == 'B'){  //check if consonant
           if(!isVowel(_wrd[i+j])){
            if(structArray[j] != null && structArray[j].equals("s")){
              tmpMatch += "C";
            }else{
            tmpMatch += "" + _wrd[i+j];
            }
           }else{
            break; 
           }
         } else if(tmp == 'Y'){ //takes anything
           if(structArray[j] != null && structArray[j].equals("s")){
              String tt = (isVowel(_wrd[i+j])) ? "V" : "C";
              tmpMatch += "" + tt;
            }else{
            tmpMatch += "" + _wrd[i+j];
            }
         }
       }
       //println("let's see: "+tmpMatch);
       if(tmpMatch.length() == subtype.length()){
       cluster.add(tmpMatch);
       }
     }
   } else if(mix == 1){ //mix
   //println("Mix!");
     String wrdStr = new String(_wrd);
     for(int i = 0; i <= _wrd.length-subtype.length(); i++){
       tmpMatch =  wrdStr.substring(i,i+subtype.length());
       //println(tmpMatch);
       String res = "";
       String delete = tmpMatch;
       //println("tmp: "+tmpMatch);
       //loop through and delete each...do chars, A/B, Y
       String sSubtype = sortMix(subtype); 
       for(int j = 0; j < sSubtype.length(); j++){
       tmp = sSubtype.charAt(j);
       if(Character.isLowerCase(tmp)){ //check if actual character
         //println(tmp + " " + delete);
         //println("index of tmp "+ delete.indexOf(""+tmp));
         if(delete.indexOf(""+tmp) != -1){ //char match!
           delete = delete.replace(""+tmp,""); //removes first match
           res += tmp;
         }else{
          //println("breaking");
          break; //move to next loop 
         }
        } else if(tmp == 'A'){    //check if vowel
          int exists = 0;
           for(int k = 0; k < delete.length(); k++){
             if(isVowel(delete.charAt(k)) || Character.toUpperCase(delete.charAt(k)) == 'Y'){
              exists = 1;
              if(structArray[j] != null && structArray[j].equals("s")){
                res += "V";
              }else{
              res += ""+delete.charAt(k);
              }
              delete = delete.replace(""+delete.charAt(k),"");
              break;  
             }
           }
           if(exists == 0){
             break;
           }
         } else if(tmp == 'B'){  //check if consonant
           int exists = 0;
           for(int k = 0; k < delete.length(); k++){
             if(!isVowel(delete.charAt(k))){
              exists = 1;
              if(structArray[j] != null && structArray[j].equals("s")){
                res += "C";
              }else{
              res += ""+delete.charAt(k);
              }
              delete = delete.replace(""+delete.charAt(k),"");
              break;  
             }
           }
           if(exists == 0){
             break;
           }
         } else if(tmp == 'Y'){ //takes anything
           if(delete.length() > 0){
             if(structArray[j] != null && structArray[j].equals("s")){
               String tt = (isVowel(delete.charAt(0))) ? "V" : "C"; 
               res += tt;
              }else{
              res += ""+delete.charAt(0);
              }
           delete = delete.replace(""+delete.charAt(0),"");
           }else{
            break; 
           }
         } 
       }
       //if it makes it here, then it should be a match
       if (delete.equals("")){
        //alpahbetically sort tmpMatch
        //char[] chars = tmpMatch.toCharArray();
        char[] chars = res.toCharArray();
        Arrays.sort(chars);
        String match = new String(chars);
       cluster.add(match); 
       }
     }
   }
     return cluster;
  }
  
  String sortMix(String subt){
   //sort - lowercase chars, A/B, Y
   String lower = "";
   String lowers = "";
   String AB = "";
   String ABs = "";
   String Y = "";
   String Ys = "";
  for(int i = 0; i < subt.length(); i++){
    if(Character.isLowerCase(subt.charAt(i))){
      lower += ""+subt.charAt(i);
      if(structArray[i] != null && structArray[i].equals("s")){
        lowers += "s";
      }else{
        lowers += "N";
      }
    }else if(subt.charAt(i) == 'A' || subt.charAt(i) == 'B'){
      AB += ""+subt.charAt(i); 
      if(structArray[i] != null && structArray[i].equals("s")){
        ABs += "s";
      }else{
        ABs += "N";
      }
      
    }else if(subt.charAt(i) == 'Y'){
     Y += ""+subt.charAt(i); 
     if(structArray[i] != null && structArray[i].equals("s")){
        Ys += "s";
      }else{
        Ys += "N";
      }
    }
  } 
   
  String f = lower+AB+Y+"_"+lowers+ABs+Ys; //this add the structure
   return f; 
  }
  
  boolean isVowel(char ch){
    String aeiou = "AEIOUaeiou";
   return  aeiou.indexOf(ch) != -1;
  }

  String getONC(Syllable _syll) { 
    String res = "";
    if (stress == 0 || stress == 1) { //make sure stress coincides (if stress == 2, then either is fine)
      //println("syllStress "+_syll._stress+" , req stress"+stress);
      if (!_syll._stress.equals(""+stress))
        return res;
    }
    //println("type: "+subtype);
    
    if (subtype.charAt(0)=='O') {    //could write this more efficiently but wouldn't speed up time. 
    //check if _{mvp}
      if(structArray[0] != null){
        res = _syll.getOnsetStruct(structArray[0]); //for this, make sure all match. 
      }else{ 
        res = _syll.returnString(_syll._onset);
      }
    } else if (subtype.charAt(0)=='N') {
      if(structArray[0] != null){
        res = _syll.getNucleusStruct(structArray[0]);
      }else{
      res = _syll.returnString(_syll._nucleus);
      }
    } else if (subtype.charAt(0)=='C') {
       if(structArray[0] != null){
         res = _syll.getCodaStruct(structArray[0]);
         if(comment)
         println("coda struct: "+res);
       }else{
        res = _syll.returnString(_syll._coda);
       }
    } 
    if (res.length() == 0) {    //not all have onset, coda, etc...
    if((subtype.charAt(0)=='C' || subtype.charAt(0)=='O') && req){
        //check for required O or C
    }else{
      res = "_null_";
    }
    }
    return res;
  }
  
  
  String getCluster2(char[] _wrd, int start, int firstA, int firstB){ //add stressed vowel
   String cluster = "";
   //ABcAY
   char tmp;
   String tmpMatch;
   if(comment)
   println(String.valueOf(_wrd)+" "+start);
   //first check if too short
   if(_wrd.length - start < subtype.length()){
       return cluster;
   }

   if(mix == 0){
   for(int i = start; i <= start; i++){
     //println("length: "+(_wrd.length-subtype.length()));
     tmpMatch = "";
     for(int j = 0; j < subtype.length(); j++){
       
       if(subtype.charAt(j) == '\''){
        continue; //will get picked up in the next round 
       }
       tmp = subtype.charAt(j);
       if(Character.isLowerCase(tmp)){ //check if actual character
         if(tmp == _wrd[i+j]){ //char match!
           tmpMatch += "" + _wrd[i+j];
         }else{
          break; //move to next loop 
         }
        } else if(tmp == 'A'){    //check if vowel
           if(isVowel(_wrd[i+j]) || Character.toUpperCase(_wrd[i+j]) == 'Y'){
             if(subtype.length() > j+1 && subtype.charAt(j+1) == '\''){ //first vowel
            //check if first vowel...
            //println(firstA+" : "+(i+j)+" "+subtype.charAt(j+1));
            if(firstA != i+j){
              break;
              }
             }
             
            if(structArray[j] != null && structArray[j].equals("s")){
              tmpMatch += "V";
            }else{
            tmpMatch += "" + _wrd[i+j];
            }
           }else{
            break; 
           }
         } else if(tmp == 'B'){  //check if consonant
         if(subtype.length() > j+1 && subtype.charAt(j+1) == '\''){ //first vowel
            //check if first vowel...
            if(firstB != i+j){
              break;
            }
           }
           if(!isVowel(_wrd[i+j])){
            if(structArray[j] != null && structArray[j].equals("s")){
              tmpMatch += "C";
            }else{
            tmpMatch += "" + _wrd[i+j];
            }
           }else{
            break; 
           }
         } else if(tmp == 'Y'){ //takes anything
         
           if(structArray[j] != null && structArray[j].equals("s")){
              String tt = (isVowel(_wrd[i+j])) ? "V" : "C";
              tmpMatch += "" + tt;
            }else{
            tmpMatch += "" + _wrd[i+j];
            if(comment)
            println("tmpmatch: "+tmpMatch);
            }
         }
       }
       if(tmpMatch.length() == subtype.replaceAll("'","").length()){
       cluster = tmpMatch;
       }
     }
     //println("cluster:"+cluster);
   } else if(mix == 1){ //mix
   //println("Mix!");
     String wrdStr = new String(_wrd);
     for(int i = start; i <= start; i++){
       tmpMatch =  wrdStr.substring(i,i+subtype.length());
       if(comment){
       println("tmpMatch: "+tmpMatch);
       }
       String res = "";
       String delete = tmpMatch;
       //println("tmp: "+tmpMatch);
       //loop through and delete each...do chars, A/B, Y
       String[] ssSubtype = split(sortMix(subtype),"_"); 
       String sSubtype = ssSubtype[0];
       String sstruct = ssSubtype[1];
       //println(sSubtype);
       for(int j = 0; j < sSubtype.length(); j++){
       tmp = sSubtype.charAt(j);
       if(Character.isLowerCase(tmp)){ //check if actual character
         //println(tmp + " " + delete);
         //println("index of tmp "+ delete.indexOf(""+tmp));
         if(delete.indexOf(""+tmp) != -1){ //char match!
           res += tmp;
           delete = delete.replaceFirst(""+tmp,""); //removes first match
           //println("del: "+delete);
         }else{
          //println("breaking");
          break; //move to next loop 
         }
        } else if(tmp == 'A'){    //check if vowel
          int exists = 0;
           for(int k = 0; k < delete.length(); k++){
             if(isVowel(delete.charAt(k)) || Character.toUpperCase(delete.charAt(k)) == 'Y'){
              exists = 1;
              if(sstruct.charAt(j) == 's'){
                res += "V";
              }else{
              res += ""+delete.charAt(k);
              }
              delete = delete.replace(""+delete.charAt(k),"");
              break;  
             }
           }
           if(exists == 0){
             break;
           }
         } else if(tmp == 'B'){  //check if consonant
           int exists = 0;
           for(int k = 0; k < delete.length(); k++){
             if(!isVowel(delete.charAt(k))){
              exists = 1;
              if(sstruct.charAt(j) == 's'){
                res += "C";
              }else{
              res += ""+delete.charAt(k);
              }
              delete = delete.replace(""+delete.charAt(k),"");
              break;  
             }
           }
           if(exists == 0){
             break;
           }
         } else if(tmp == 'Y'){ //takes anything
           if(delete.length() > 0){
             if(sstruct.charAt(j) == 's'){
               String tt = (isVowel(delete.charAt(0))) ? "V" : "C"; 
               res += tt;
              }else{
              res += ""+delete.charAt(0);
              }
           delete = delete.replace(""+delete.charAt(0),"");
           }else{
            break; 
           }
         } 
       }
       //if it makes it here, then it should be a match
       if (delete.equals("")){
        //alpahbetically sort tmpMatch
        //char[] chars = tmpMatch.toCharArray();
        char[] chars = res.toCharArray();
        Arrays.sort(chars);
        String match = new String(chars);
       cluster = match; 
       }
     }
   }
     return cluster;
  }
};

